'////////////////////////////////////////////////////////////////////////////////
'//
'//	Annihilation
'//	By Andy Noble
'//
'//	Started: 01/12/2005
'//	Finished:
'//
'//	ToDo:
'//	-----
'//	Add a PUSH to Black Hole Explode (pushes stuff away not grid based)
'//	Check for Blackholes at Corners before Spawning there
'//	Sort out EXE Icon
'//	Add another set of Attachwaves at double difficulty.
'//
'////////////////////////////////////////////////////////////////////////////////

Framework BRL.GLMax2D

Import BRL.D3D7Max2D
Import BRL.System
Import Pub.FreeJoy
Import BRL.Random
Import BRL.PNGLoader
Import BRL.FreeAudioAudio
Import BRL.OGGLoader
Import BRL.Retro

?Win32
Import "projecticon.o"
?

SuperStrict
'////////////////////////////////////////////////////////////////////////////////
'//	Code Includes
'////////////////////////////////////////////////////////////////////////////////
Include	"setup.bmx"
Include	"load.bmx"
Include	"fps.bmx"
Include	"debug.bmx"
Include	"window.bmx"
Include	"print.bmx"
Include	"drawlist.bmx"
Include	"gamelogic.bmx"
Include	"titles.bmx"
Include	"score.bmx"
Include	"game.bmx"
Include	"border.bmx"
Include	"stars.bmx"
Include	"player.bmx"
Include	"bullets.bmx"
Include	"bomb.bmx"
Include	"particles.bmx"
Include	"explosion.bmx"
Include	"nme.bmx"
Include	"nmespinner.bmx"
Include	"nmefloater.bmx"
Include	"nmescare.bmx"
Include	"nmesplitter.bmx"
Include	"nmespawn.bmx"
Include	"nmeswamer.bmx"
Include	"nmesnake.bmx"
Include	"nmeclone.bmx"
Include	"nmeblackhole.bmx"
Include	"nmeholespore.bmx"
Include	"highscore.bmx"
Include	"attack.bmx"
Include	"sfx.bmx"
Include	"bmlogo.bmx"
Include	"retro.bmx"
Include	"uploadscore.bmx"
'////////////////////////////////////////////////////////////////////////////////
'//	Load all external resources
'////////////////////////////////////////////////////////////////////////////////
LoadAll()
'////////////////////////////////////////////////////////////////////////////////
'//	Main Loop
'////////////////////////////////////////////////////////////////////////////////
Repeat
	Repeat
		SUelapsed=MilliSecs()-SUtime
	Until SUelapsed

	SUticks=SUelapsed/SUperiod
	If SUticks>1000 Then SUticks=1
	For SU=1 To SUticks
		SUtime=SUtime+SUperiod
		UpdateLogic()
	Next

	Cls()
	RenderAll()

	FPS()	'DoDebug()

	Flip(0)
Until QUIT=1
'////////////////////////////////////////////////////////////////////////////////
'//	Clean Up
'////////////////////////////////////////////////////////////////////////////////
SaveConfig()
SaveHighscores()
'////////////////////////////////////////////////////////////////////////////////
'//	End Program
'////////////////////////////////////////////////////////////////////////////////
End







