'////////////////////////////////////////////////////////////////////////////////
'//	Variables
'////////////////////////////////////////////////////////////////////////////////
Global	GFXbmlbg:TImage
Global	GFXbmlblitz:TImage
Global	GFXbmlmax:TImage
Global	GFXbmlline:TImage
Global	GFXbmlcover:TImage
Global	GFXbmlshine:TImage

Global	SFXbmlsound:TSound
Global	SFXbmlsoundCH:TChannel

Global	BMLmode:Int=1
Global	BMLbgalpha:Int=-64
Global	BMLblitzalpha:Float=0
Global	BMLblitzy:Float=(GFXh/2)-128
Global	BMLmaxy:Float=(GFXh/2)+128
Global	BMLlinealpha:Float=0
Global	BMLlinex:Float=(GFXw/2)-256
Global	BMLsparkalpha:Float=0
Global	BMLsparkscale:Float=4
Global	BMLfade:Float=384
Global	BMLshine:Float=0
Global	BMLsp:Int=0
Global	BMLdown:Int=1

'////////////////////////////////////////////////////////////////////////////////
'//	DoLogo
'////////////////////////////////////////////////////////////////////////////////
Function	BMLDoBlitzLogo(ret:Int)
	ClearList(DRAWlist)

	Select	BMLmode
		Case	1
			BMLDrawLogoBG()
		Case	2
			BMLDrawLogoBlitz()
		Case	3
			BMLDrawLogoLine()
		Case	4
			BMLFadeLogo()
		Case	5
			If SFXbmlsoundCH<>Null
				StopChannel(SFXbmlsoundCH)
			End If
			MODE=ret
	End Select

	If (AnyKey()=1 Or AnyJoy()=1 Or MouseDown(1) Or MouseDown(2)) And BMLmode<4
		If BMLdown=0
			BMLmode=4
			BMLdown=1
		End If
	Else
		BMLdown=0
	End If

	DoParticles()
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Draw Logo Background
'////////////////////////////////////////////////////////////////////////////////
Function	BMLDrawLogoBG()
	AddImage(GFXbmlbg,GFXw/2,GFXh/2,0,BMLbgalpha,BMLbgalpha,BMLbgalpha,1)

	BMLbgalpha:+5
	If BMLbgalpha>255
		BMLmode=2
	End If

	If BMLsp=0 And BMLbgalpha>0
		SFXbmlsoundCH=PlaySound(SFXbmlsound)
		BMLsp=1
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Draw Logo Blitz
'////////////////////////////////////////////////////////////////////////////////
Function	BMLDrawLogoBlitz()
	AddImage(GFXbmlbg,GFXw/2,GFXh/2,0,255,255,255,1)

	AddImage(GFXbmlblitz,GFXw/2,BMLblitzy,0,255,255,255,BMLblitzalpha)
	AddImage(GFXbmlmax,GFXw/2,BMLmaxy,0,255,255,255,BMLblitzalpha)

	If BMLblitzalpha<1
		BMLblitzalpha:+0.01
	End If

	If BMLblitzy<(GFXh/2)
		BMLblitzy=BMLblitzy+((((GFXh/2)+1)-BMLblitzy)/32)
	End If

	If BMLmaxy>(GFXh/2)
		BMLmaxy=BMLmaxy+((((GFXh/2)-1)-BMLmaxy)/32)
	Else
		BMLmode=3
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Draw Logo Line
'////////////////////////////////////////////////////////////////////////////////
Function	BMLDrawLogoLine()
	Local	part:tPART
	Local	i:Int

'	AddImage(GFXbmlshine,GFXw/2,GFXh/2,0,BMLfade,BMLfade,BMLfade,BMLshine)
	AddImage(GFXbmlbg,GFXw/2,GFXh/2,0,255,255,255,1)
	AddImage(GFXbmlblitz,GFXw/2,GFXh/2,0,255,255,255,1)
	AddImage(GFXbmlmax,GFXw/2,GFXh/2,0,255,255,255,1)

	AddImage(GFXbmlline,BMLlinex,GFXh/2,0,255,255,255,BMLlinealpha)
	AddImage(GFXbmlcover,(GFXw/2)-220,GFXh/2,0,255,255,255,1)

	AddImage(GFXbmlshine,GFXw/2,GFXh/2,0,BMLfade,BMLfade,BMLfade,BMLshine,0,1,1,lightblend)

	If BMLlinealpha<1
		BMLlinealpha:+0.01
		BMLsparkalpha:+0.05
	End If

	If BMLlinex<(GFXw/2)
		BMLlinex=BMLlinex+((((GFXw/2)+1)-BMLlinex)/32)

		If BMLlinex>((GFXw/2)-8)
			BMLshine:+0.01
		End If

		If BMLlinex<((GFXw/2)-8)
		For i=0 To 2
			part:tPART = New tPART
			part.t=3
			part.accel=Rnd(1,3)
			part.accelchange=-0.05
			part.ang=Rnd(0,359)
			part.angchange=0
			part.x=BMLlinex+108
			part.y=(GFXh/2)+56
			part.rot=0
			part.rotchange=0
			part.alpha=BMLsparkalpha
			part.alphachange=-0.1
			part.xscale=BMLsparkscale
			part.yscale=BMLsparkscale
			part.xscalechange=-0.1
			part.yscalechange=-0.1
			part.img=GFXstar02
			part.blend=LIGHTBLEND
			part.r=255
			part.g=Rand(128,255)
			part.b=32
			part.collrad=0
			ListAddLast(particlelist,part)
		Next
		End If
	Else
		BMLmode=4
		'BMLshine=1
	End If

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Draw Logo Line
'////////////////////////////////////////////////////////////////////////////////
Function	BMLFadeLogo()
	Local	part:tPART
	Local	i:Int

'	AddImage(GFXbmlshine,GFXw/2,GFXh/2,0,BMLfade,BMLfade,BMLfade,BMLshine)
	AddImage(GFXbmlbg,GFXw/2,GFXh/2,0,BMLfade,BMLfade,BMLfade,1)
	AddImage(GFXbmlblitz,GFXw/2,GFXh/2,0,BMLfade,BMLfade,BMLfade,1)
	AddImage(GFXbmlmax,GFXw/2,GFXh/2,0,BMLfade,BMLfade,BMLfade,1)
	AddImage(GFXbmlline,GFXw/2,GFXh/2,0,BMLfade,BMLfade,BMLfade,1)

	AddImage(GFXbmlshine,GFXw/2,GFXh/2,0,BMLfade,BMLfade,BMLfade,BMLshine,0,1,1,lightblend)

	BMLshine:-0.01

	If BMLfade>-(4*40)
		BMLfade:-4
	Else
		BMLmode=5
	End If


End Function


