'////////////////////////////////////////////////////////////////////////////////
'//	Add Blackhole
'////////////////////////////////////////////////////////////////////////////////
'counter1=number of rezes / counter2=scale / counter3=free / counter4=free / counter5=Max Energy
Function	AddHole(xpos:Float,ypos:Float)
	Local	i:tNME
	Local	done:Int
	Local	dis:Float

	i:tNME = New tNME
	i.t=7
	i.mode=0
	i.collrad=24

	done=0
	If xpos=0 And ypos=0
		Repeat
			i.x=Rand(WINleft+i.collrad,WINright-i.collrad)
			i.y=Rand(WINtop+i.collrad,WINbot-i.collrad)
			dis=Sqr(((i.x-PLAYERx)*(i.x-PLAYERx))+((i.y-PLAYERy)*(i.y-PLAYERy)))
			If dis>(PLAYERcollrad*6)
				done=1
			End If
		Until(done=1)
	Else
		i.x=xpos
		i.y=ypos
	End If
	i.ang=0
	i.speed=0
	i.img=GFXnme10
	i.xscale=1
	i.yscale=1
	i.alpha=0
	i.blend=LIGHTBLEND
	i.rot=0
	i.r=255
	i.g=32
	i.b=8
	i.energy=1000
	i.score=150
	i.counter1=0
	i.counter2=1	
	i.counter5=0
	i.iamtheone=0
	If i.x<(WINleft+i.collrad)
		i.x=(WINleft+i.collrad)
	Else
		If i.x>(WINright-i.collrad)
			i.x=(WINright-i.collrad)
		End If
	End If

	If i.y<(WINtop+i.collrad)
		i.y=(WINtop+i.collrad)
	Else
		If i.y>(WINbot-i.collrad)
			i.y=(WINbot-i.collrad)
		End If
	End If
	ListAddLast(NMElist,i)

	AddSFX(cSFXnme08spawn,i.x)

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Black Hole
'////////////////////////////////////////////////////////////////////////////////
Function	DoHole(i:tNME)

	Select	i.mode
		Case	0
			RezInHole(i)
		Case	1
			DoHoleSearch(i)
		Case	2
			KillHole(i)
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Rez In Hole
'////////////////////////////////////////////////////////////////////////////////
'counter1=number of rezes / counter2=scale / counter3=free / counter4=free / counter5=Max Energy
Function	RezInHole(i:tNME)

	AddImage(i.img,i.x-WINDOWx,i.y-WINDOWy,0,i.r,i.g,i.b,i.alpha,i.rot,i.counter2,i.counter2,LIGHTBLEND)

	AddImage(i.img,i.x-WINDOWx,i.y-WINDOWy,0,i.r,i.g,i.b,i.alpha,i.rot,(i.counter2+1)Mod 2,(i.counter2+1)Mod 2,LIGHTBLEND)

	i.alpha:+0.025

	i.counter2:+0.125

	If i.counter2=2
		i.counter2=1
		i.counter1:+1
		If i.counter1=6
			i.alpha=1
			i.counter1=0
			i.counter2=0
			i.counter3=10
			i.counter4=0
			i.counter5=0
			i.mode=1
		End If
	End If
	'gridpoint.push(i.x-WINleft,i.y-WINtop,i.collrad+(i.alpha*2),10-(i.alpha*5))
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Hole Search
'////////////////////////////////////////////////////////////////////////////////
'counter1=mode / counter2=strobe / counter3=strobe speed / counter4=coloud rot / counter5=free
Function	DoHoleSearch(i:tNME)
	Local	j:Int
	Local	p:tPART
	Local	ang:Float
	Local	scale:Float

	If i.x<(WINleft+i.collrad)
		i.x=(WINleft+i.collrad)
	Else
		If i.x>(WINright-i.collrad)
			i.x=(WINright-i.collrad)
		End If
	End If

	If i.y<(WINtop+i.collrad)
		i.y=(WINtop+i.collrad)
	Else
		If i.y>(WINbot-i.collrad)
			i.y=(WINbot-i.collrad)
		End If
	End If

	Select	i.counter1
		Case	0
			AddImage(i.img,i.x-WINDOWx,i.y-WINDOWy,0,i.r,64+(Sin(i.counter2)*64),64+(Sin(i.counter2)*64),i.alpha,i.rot,i.xscale,i.yscale,ALPHABLEND)
		Case	1
			AddImage(GFXnme10c,i.x-WINDOWx,i.y-WINDOWy,0,i.r,i.g,i.b,0.25,-(i.counter4/4),3,3,LIGHTBLEND)
			AddImage(GFXnme10b,i.x-WINDOWx,i.y-WINDOWy,0,i.r,i.g,i.b,1,i.counter4,3,3,LIGHTBLEND)
			scale=Rnd(1,1+(i.energy/6000))
			AddImage(i.img,i.x-WINDOWx,i.y-WINDOWy,0,i.r,64+(Sin(i.counter2)*64),64+(Sin(i.counter2)*64),i.alpha,i.rot,scale,scale,ALPHABLEND)
			gridpoint.pull(i.x-WINleft,i.y-WINtop,10+((i.energy/100)/4))
			i.energy:+2
	End Select

	i.counter3=(i.energy/(360/2))

	i.counter2=(i.counter2+i.counter3)
	If i.counter2>360
		i.counter2:-360
		If i.counter1=1
			AddSFX(cSFXhole,i.x)
		End If
	End If
	i.counter4=(i.counter4+5)Mod (360*4)

	If i.energy>6000
		i.mode=2
		i.score=0
		For j=0 To Rand(8,16)
			ang=Rnd(0,359)
			AddHoleSpore(i.x+Sin(ang)*(i.collrad*2),i.y+Cos(ang)*(i.collrad*2))
		Next
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Kill Clone
'////////////////////////////////////////////////////////////////////////////////
Function	KillHole(i:tNME)
	Local	part:tPART
	Local	j:Int
	Local	ang:Float

	AddExplosion(i.x,i.y)
	part:tPART = New tPART
	part.t=1
	part.accel=0.0000001
	part.accelchange=0
	part.ang=0
	part.angchange=0
	part.x=i.x
	part.y=i.y
	part.rot=Rand(0,359)
	part.rotchange=0
	part.alpha=1
	part.alphachange=-0.04
	part.xscale=0
	part.yscale=0
	part.xscalechange=0.25'0.075
	part.yscalechange=0.25'0.075
	part.img=GFXplayerbomb01
	part.blend=LIGHTBLEND
	part.r=i.r
	part.g=i.g
	part.b=i.b
	part.collrad=0
	ListAddLast(particlelist,part)

	part:tPART = New tPART
	part.t=1
	part.accel=0.0000001
	part.accelchange=0
	part.ang=0
	part.angchange=0
	part.x=i.x
	part.y=i.y
	part.rot=Rand(0,359)
	part.rotchange=0
	part.alpha=1
	part.alphachange=-0.04
	part.xscale=0
	part.yscale=0
	part.xscalechange=0.5'0.075
	part.yscalechange=0.5'0.075
	part.img=GFXplayerbomb01
	part.blend=LIGHTBLEND
	part.r=i.r
	part.g=i.g
	part.b=i.b
	part.collrad=0
	ListAddLast(particlelist,part)

	part:tPART = New tPART
	part.accel=0.0000001
	part.accelchange=0
	part.ang=0
	part.angchange=0
	part.x=i.x
	part.y=i.y
	part.rot=i.rot
	part.rotchange=0
	part.alpha=1
	part.xscale=i.xscale
	part.yscale=i.yscale
	part.img=GFXnme10
	part.blend=LIGHTBLEND
	part.r=i.r
	part.g=i.g
	part.b=i.b
	part.collrad=0
	If i.iamtheone=0
		part.t=1
		part.alphachange=-0.05
		part.xscalechange=0.075
		part.yscalechange=0.075
	Else
		part.t=2
		part.alphachange=0
		part.xscalechange=0
		part.yscalechange=0
		part.rcolchange=1
		part.gcolchange=8
		part.bcolchange=1
	End If
	ListAddLast(particlelist,part)

	UpdateScore(i.score,i.x,i.y)

	nmelist.Remove i
	If i.score<>0
		debugTOTALKILLED:+1
		debugTOTALKILLEDNODEATH:+1
		KILLtype[i.t]:+1
		gridpoint.pull(i.x-GRIDxoff,i.y-GRIDyoff,48,-8)
	End If
	gridpoint.pull(i.x-GRIDxoff,i.y-GRIDyoff,32,-8)
	AddSFX(cSFXholeexp,i.x)
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Count Holes
'////////////////////////////////////////////////////////////////////////////////
Function	CountHoles:Int()
	Local	i:tNME
	Local	total:Int

	total=0

	For	i:tNME = EachIn NMElist
		If i.t=7
			total:+1
		End If
	Next

	Return(total)
End Function





