'////////////////////////////////////////////////////////////////////////////////
'//	Add Spinner
'////////////////////////////////////////////////////////////////////////////////
'counter1=number of rezes / counter2=scale / counter3=free / counter4=free / counter5=free
Function	AddHoleSpore(xpos:Float,ypos:Float,ang:Float=0)
	Local	i:tNME
	Local	done:Int
	Local	dis:Float

	i:tNME = New tNME
	i.t=8
	i.mode=0
	i.collrad=12

	done=0
	If xpos=0 And ypos=0
		Repeat
			i.x=Rand(WINleft+i.collrad,WINright-i.collrad)
			i.y=Rand(WINtop+i.collrad,WINbot-i.collrad)
			dis=Sqr(((i.x-PLAYERx)*(i.x-PLAYERx))+((i.y-PLAYERy)*(i.y-PLAYERy)))
			If dis>(PLAYERcollrad*8)
				done=1
			End If
		Until(done=1)
	Else
		i.x=xpos
		i.y=ypos
	End If
	i.ang=ang'ATan2(PLAYERy-i.y,PLAYERx-i.x)-90
	i.speed=PLAYERMAXACCEL
	i.img=GFXnme08
	i.xscale=1
	i.yscale=1
	i.alpha=0
	i.blend=LIGHTBLEND
	i.rot=0
	i.r=255
	i.g=255
	i.b=24
	i.energy=50
	i.score=50
	i.counter1=0
	i.counter2=1	
	i.iamtheone=0
	If i.x<(WINleft+i.collrad)
		i.x=(WINleft+i.collrad)
	Else
		If i.x>(WINright-i.collrad)
			i.x=(WINright-i.collrad)
		End If
	End If

	If i.y<(WINtop+i.collrad)
		i.y=(WINtop+i.collrad)
	Else
		If i.y>(WINbot-i.collrad)
			i.y=(WINbot-i.collrad)
		End If
	End If
	ListAddLast(NMElist,i)

	'AddSFX(cSFXnme01spawn,i.x)

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Floater
'////////////////////////////////////////////////////////////////////////////////
Function	DoHoleSpore(i:tNME)

	Select	i.mode
		Case	0
			RezInHoleSpore(i)
		Case	1
			DoHoleSporeSearch(i)
		Case	2
			KillHoleSpore(i)
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Rez In Floater
'////////////////////////////////////////////////////////////////////////////////
'counter1=number of rezes / counter2=scale / counter3=free / counter4=free / counter5=free
Function	RezInHoleSpore(i:tNME)
	i.alpha=1
	i.mode=1
	i.counter1=Rnd(1,2)
	i.counter2=Rnd(REQfps,(REQfps*2))
	i.counter3=0
	i.counter4=0
	i.counter5=0
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Floater Search
'////////////////////////////////////////////////////////////////////////////////
'counter1=Speed / counter2=Speed Pause / counter3=free / counter4=free / counter5=free
Function	DoHoleSporeSearch(i:tNME)
	Local	ox:Float
	Local	oy:Float
	Local	la:Float

	If i.speed<(PLAYERMAXACCEL*i.counter1)
		i.speed:+0.125
	Else
		If i.speed>0
			i.speed:-0.125
		End If
	End If

	i.counter2:-1
	If i.counter2<0
		i.counter1=Rnd(1,2)
		i.counter2=Rnd(REQfps,(REQfps*2))
	End If

	la=ATan2(PLAYERx-i.x,PLAYERy-i.y)
	If (la-i.ang)>180
		la:-360
	Else
		If (la-i.ang)<-180
			la:+360
		End If
	End If

	If la>(i.ang)
		i.ang:+2
		i.ang=(i.ang Mod 360)
	Else
		If la<(i.ang)
			i.ang:-2
			i.ang=(i.ang Mod 360)
		End If
	End If

	ox=i.x
	oy=i.y

	i.x=ox+Sin(i.ang)*i.speed
	i.y=oy+Cos(i.ang)*i.speed

	If i.x<(WINleft+i.collrad)
		i.x=(WINleft+i.collrad)
	Else
		If i.x>(WINright-i.collrad)
			i.x=(WINright-i.collrad)
		End If
	End If

	If i.y<(WINtop+i.collrad)
		i.y=(WINtop+i.collrad)
	Else
		If i.y>(WINbot-i.collrad)
			i.y=(WINbot-i.collrad)
		End If
	End If

	AddImage(i.img,i.x-WINDOWx,i.y-WINDOWy,0,i.r,i.g,i.b,i.alpha,i.rot,i.xscale,i.yscale,i.blend)

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Kill Floater
'////////////////////////////////////////////////////////////////////////////////
Function	KillHoleSpore(i:tNME)
	Local	part:tPART

	AddExplosion(i.x,i.y)

	part:tPART = New tPART
	part.accel=0.0000001
	part.accelchange=0
	part.ang=0
	part.angchange=0
	part.x=i.x
	part.y=i.y
	part.rot=i.rot
	part.rotchange=0
	part.alpha=1
	part.xscale=i.xscale
	part.yscale=i.yscale
	part.img=GFXnme08
	part.blend=LIGHTBLEND
	part.r=i.r
	part.g=i.g
	part.b=i.b
	part.collrad=0
	If i.iamtheone=0
		part.t=1
		part.alphachange=-0.05
		part.xscalechange=0.075
		part.yscalechange=0.075
	Else
		part.t=2
		part.alphachange=0
		part.xscalechange=0
		part.yscalechange=0
		part.rcolchange=1
		part.gcolchange=8
		part.bcolchange=1
	End If
	ListAddLast(particlelist,part)

	UpdateScore(i.score,i.x,i.y)

	nmelist.remove i
	If i.score<>0
		debugTOTALKILLED:+1
		debugTOTALKILLEDNODEATH:+1
		AddSFX(cSFXnmekill,i.x)
		KILLtype[i.t]:+1
	End If
	'BORDERz1[BORDERbuf,i.x/32,i.y/32]=BORDERsplash/2
	gridpoint.shockwave(i.x-GRIDxoff,i.y-GRIDyoff)
End Function
