'////////////////////////////////////////////////////////////////////////////////
'//	Add Spinner
'////////////////////////////////////////////////////////////////////////////////
'counter1=number of rezes / counter2=scale / counter3=free / counter4=free / counter5=free
Function	AddSnake(xpos:Float,ypos:Float)
	Local	i:tNME
	Local	done:Int
	Local	dis:Float
	Local	j:Int

	i:tNME = New tNME
	i.t=5
	i.mode=0
	i.collrad=12

	done=0
	If xpos=0 And ypos=0
		Repeat
			i.x=Rand(WINleft+i.collrad,WINright-i.collrad)
			i.y=Rand(WINtop+i.collrad,WINbot-i.collrad)
			dis=Sqr(((i.x-PLAYERx)*(i.x-PLAYERx))+((i.y-PLAYERy)*(i.y-PLAYERy)))
			If dis>(PLAYERcollrad*8)
				done=1
			End If
		Until(done=1)
	Else
		i.x=xpos
		i.y=ypos
	End If
	i.ang=ATan2(PLAYERy-i.y,PLAYERx-i.x)-90
	i.speed=0
	i.img=GFXnme07
	i.xscale=1
	i.yscale=1
	i.alpha=0
	i.blend=LIGHTBLEND
	i.rot=(-i.ang)+180
	i.r=96
	i.g=32
	i.b=255
	i.energy=50
	i.score=150
	i.counter1=0
	i.counter2=1	
	For j=0 To (SNAKETAILLENGTH*SNAKETAILSTEP)
		i.tabx[j]=-1
		i.taby[j]=-1
	Next
	i.iamtheone=0
	If i.x<(WINleft+i.collrad)
		i.x=(WINleft+i.collrad)
	Else
		If i.x>(WINright-i.collrad)
			i.x=(WINright-i.collrad)
		End If
	End If

	If i.y<(WINtop+i.collrad)
		i.y=(WINtop+i.collrad)
	Else
		If i.y>(WINbot-i.collrad)
			i.y=(WINbot-i.collrad)
		End If
	End If
	ListAddLast(NMElist,i)

	AddSFX(cSFXnme06spawn,i.x)


End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Spinner
'////////////////////////////////////////////////////////////////////////////////
Function	DoSnake(i:tNME)

	Select	i.mode
		Case	0
			RezInSnake(i)
		Case	1
			DoSnakeSearch(i)
		Case	2
			KillSnake(i)
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Rez In Floater
'////////////////////////////////////////////////////////////////////////////////
'counter1=number of rezes / counter2=scale / counter3=free / counter4=free / counter5=free
Function	RezInSnake(i:tNME)
	AddImage(GFXnme07,i.x-WINDOWx,i.y-WINDOWy,0,i.r,i.g,i.b,i.alpha,i.rot,i.counter2,i.counter2,LIGHTBLEND)

	AddImage(GFXnme07,i.x-WINDOWx,i.y-WINDOWy,0,i.r,i.g,i.b,i.alpha,i.rot,(i.counter2+1)Mod 2,(i.counter2+1)Mod 2,LIGHTBLEND)

	i.alpha:+0.025

	i.counter2:+0.125

	If i.counter2=2
		i.counter2=1
		i.counter1:+1
		If i.counter1=6
			i.alpha=1
			i.counter1=Rand(0,359)
			i.counter3=1
			i.mode=1
			i.counter2=0
			i.counter4=0
			i.counter5=0
		End If
	End If
	'gridpoint.push(i.x-WINleft,i.y-WINtop,i.collrad+(i.alpha*2),10-(i.alpha*5))
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Spinner Search
'////////////////////////////////////////////////////////////////////////////////
'counter1=wobble / counter2=search mode / counter3=free / counter4=targetx / counter5=targety
Function	DoSnakeSearch(i:tNME)
	Local	done:Int
	Local	xp:Float
	Local	yp:Float
	Local	dis:Float
	Local	ox:Float
	Local	oy:Float
	Local	j:Int
	Local	trot:Float

	Select i.counter2
		Case	0' Find a point to go to
			done=0
			Repeat
				xp=Rand(WINleft+i.collrad,WINright-i.collrad)
				yp=Rand(WINtop+i.collrad,WINbot-i.collrad)
				dis=Sqr(((i.x-xp)*(i.x-xp))+((i.y-yp)*(i.y-yp)))
				If dis>(i.collrad*4)
					done=1
				End If
			Until(done=1)
			i.ang=ATan2(i.counter4-i.x,i.counter5-i.y)
			i.counter4=xp
			i.counter5=yp
			i.counter2=1
		Case	1
			i.ang=ATan2(i.counter4-i.x,i.counter5-i.y)
			i.ang:+Sin(i.counter1)*90
			ox=i.x
			oy=i.y

			If i.speed<(PLAYERMAXACCEL)
				i.speed:+0.125
			Else
				If i.speed>0
					i.speed:-0.125
				End If
			End If

			i.x=ox+Sin(i.ang)*i.speed
			i.y=oy+Cos(i.ang)*i.speed

			If i.x<(WINleft+i.collrad)
				i.x=(WINleft+i.collrad)
			Else
				If i.x>(WINright-i.collrad)
					i.x=(WINright-i.collrad)
				End If
			End If

			If i.y<(WINtop+i.collrad)
				i.y=(WINtop+i.collrad)
			Else
				If i.y>(WINbot-i.collrad)
					i.y=(WINbot-i.collrad)
				End If
			End If

			For j=((SNAKETAILLENGTH*SNAKETAILSTEP)-2) To 0 Step -1
				i.tabx[j+1]=i.tabx[j]
				i.taby[j+1]=i.taby[j]
			Next
			i.tabx[0]=i.x
			i.taby[0]=i.y

			dis=Sqr(((i.x-i.counter4)*(i.x-i.counter4))+((i.y-i.counter5)*(i.y-i.counter5)))
			If dis<i.collrad
				i.counter2=0
			End If
	End Select

	i.rot=(-i.ang)+180

	For j=1 To SNAKETAILLENGTH
		If i.tabx[j*SNAKETAILSTEP]<>-1
			If j=1
				trot=ATan2(i.taby[j*SNAKETAILSTEP]-i.y,i.tabx[j*SNAKETAILSTEP]-i.x)-90
			Else
				trot=ATan2(i.taby[j*SNAKETAILSTEP]-i.taby[(j-1)*SNAKETAILSTEP],i.tabx[j*SNAKETAILSTEP]-i.tabx[(j-1)*SNAKETAILSTEP])-90
			End If
			AddImage(GFXnme07b,i.tabx[j*SNAKETAILSTEP]-WINDOWx,i.taby[j*SNAKETAILSTEP]-WINDOWy,0,255,128,32,1,trot,1-(j*(1/(SNAKETAILLENGTH*1.5))),1,LIGHTBLEND)
		End If
	Next

	AddImage(i.img,i.x-WINDOWx,i.y-WINDOWy,0,i.r,i.g,i.b,i.alpha,i.rot,i.xscale,i.yscale,LIGHTBLEND)

	i.counter1=(i.counter1+2)Mod 360

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Kill Spinner
'////////////////////////////////////////////////////////////////////////////////
Function	KillSnake(i:tNME)
	Local	part:tPART
	Local	r:Int
	Local	g:Int
	Local	b:Int
	Local	j:Int
	Local	trot:Float
	Local	mr:Float
	Local	k:Int


	If i.counter3=1
		AddExplosion(i.x,i.y)
		UpdateScore(i.score,i.x,i.y)
		'BORDERz1[BORDERbuf,i.x/32,i.y/32]=BORDERsplash
		gridpoint.shockwave(i.x-GRIDxoff,i.y-GRIDyoff)

		part:tPART = New tPART
		part.accel=0.0000001
		part.accelchange=0
		part.ang=0
		part.angchange=0
		part.x=i.x
		part.y=i.y
		part.rot=i.rot
		part.rotchange=0
		part.alpha=1
		part.xscale=i.xscale
		part.yscale=i.yscale
		part.img=GFXnme07
		part.blend=LIGHTBLEND
		part.r=i.r
		part.g=i.g
		part.b=i.b
		part.collrad=0
		If i.iamtheone=0
			part.t=1
			part.alphachange=-0.05
			part.xscalechange=0.075
			part.yscalechange=0.075
		Else
			part.t=2
			part.alphachange=0
			part.xscalechange=0
			part.yscalechange=0
			part.rcolchange=1
			part.gcolchange=8
			part.bcolchange=1
		End If

		ListAddLast(particlelist,part)

		For j=1 To SNAKETAILLENGTH
			If i.tabx[j*SNAKETAILSTEP]<>-1
				If j=1
					trot=ATan2(i.taby[j*SNAKETAILSTEP]-i.y,i.tabx[j*SNAKETAILSTEP]-i.x)-90
				Else
					trot=ATan2(i.taby[j*SNAKETAILSTEP]-i.taby[(j-1)*SNAKETAILSTEP],i.tabx[j*SNAKETAILSTEP]-i.tabx[(j-1)*SNAKETAILSTEP])-90
				End If
				part:tPART = New tPART
				part.accel=0.0000001
				part.accelchange=0
				part.ang=0
				part.angchange=0
				part.x=i.tabx[j*SNAKETAILSTEP]
				part.y=i.taby[j*SNAKETAILSTEP]
				part.rot=trot
				part.rotchange=0
				part.alpha=1
				part.xscale=1-(j*(1/(SNAKETAILLENGTH*1.5)))
				part.yscale=1
				part.img=GFXnme07b
				part.blend=LIGHTBLEND
				part.r=255
				part.g=128
				part.b=32
				part.collrad=0
				If i.iamtheone=0
					part.t=1
					part.alphachange=-0.05
					part.xscalechange=-0.075
					part.yscalechange=-0.075
				Else
					part.t=2
					part.alphachange=0
					part.xscalechange=0
					part.yscalechange=0
					part.rcolchange=1
					part.gcolchange=8
					part.bcolchange=1
				End If
				ListAddLast(particlelist,part)
			End If
		Next
		AddSFX(cSFXnmekill,i.x)
	End If

	j=i.counter3
	If i.tabx[j*SNAKETAILSTEP]<>-1
		AddExplosionRed(i.tabx[j*SNAKETAILSTEP],i.taby[j*SNAKETAILSTEP])
		'BORDERz1[BORDERbuf,i.tabx[j*SNAKETAILSTEP]/32,i.taby[j*SNAKETAILSTEP]/32]=BORDERsplash/2
		gridpoint.shockwave(i.tabx[j*SNAKETAILSTEP]-GRIDxoff,i.taby[j*SNAKETAILSTEP]-GRIDyoff)
	End If

	i.counter3:+1
	If i.counter3=SNAKETAILLENGTH
		nmelist.remove i
		If i.score<>0
			debugTOTALKILLED:+1
			debugTOTALKILLEDNODEATH:+1
			KILLtype[i.t]:+1
		End If
	End If
End Function
