'////////////////////////////////////////////////////////////////////////////////
'//	Variables
'////////////////////////////////////////////////////////////////////////////////
Const	MAXPARTICLES:Int=100000

Type	tPART
	Field	t:Int				'type
	Field	x:Float				'x
	Field	y:Float				'y
	Field	accel:Float			'acceleration
	Field	accelchange:Float	'acceleration change
	Field	ang:Float			'angle from origin
	Field	angchange:Float		'angle change
	Field	rot:Float			'rotation
	Field	rotchange:Float		'rotation change
	Field	alpha:Float			'alpha
	Field	alphachange:Float	'alpha change
	Field	xscale:Float		'x scale
	Field	yscale:Float		'y scale
	Field	xscalechange:Float	'x scale change
	Field	yscalechange:Float	'y scale change
	Field	img:TImage			'graphic
	Field	blend:Int			'blend
	Field	r:Int				'red
	Field	g:Int				'green
	Field	b:Int				'blue
	Field	rcolchange:Int		'Colour Change
	Field	gcolchange:Int		'Colour Change
	Field	bcolchange:Int		'Colour Change
	Field	collrad:Float		'collision radius
End Type
Global PARTICLElist:TList=CreateList()

Global	GFXpart01:TImage
Global	GFXpart02:TImage
'////////////////////////////////////////////////////////////////////////////////
'//	Add Particles
'////////////////////////////////////////////////////////////////////////////////
Function	AddParticle(t:Int,x:Float,y:Float,accel:Float,accelchange:Float,ang:Float,angchange:Float,rot:Float,rotchange:Float,alpha:Float,alphachange:Float,xscale:Float,yscale:Float,xscalechange:Float,yscalechange:Float,img:timage,blend:Int,r:Int,g:Int,b:Int,collrad:Float)
	Local	part:tPART

	If PARTICLElist.count()<MAXPARTICLES
		part:tPART = New tPART
		part.t=t
		part.x=x
		part.y=y
		part.accel=accel
		part.accelchange=accelchange
		part.ang=ang
		part.angchange=angchange
		part.rot=rot
		part.rotchange=rotchange
		part.alpha=alpha
		part.alphachange=alphachange
		part.xscale=xscale
		part.yscale=yscale
		part.xscalechange=xscalechange
		part.yscalechange=yscalechange
		part.img=img
		part.blend=blend
		part.r=r
		part.g=g
		part.b=b
		part.collrad=collrad
		ListAddLast(PARTICLElist,part)
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Particles
'////////////////////////////////////////////////////////////////////////////////
Function	DoParticles()
	Local	i:tPART
	Local	xp:Float
	Local	yp:Float
	Local	ang:Float

	For	i:tPART = EachIn particlelist
		Select	i.t
			Case	0
				i.accel:+i.accelchange
				i.alpha:+i.alphachange
				i.rot:+i.rotchange
				i.xscale:+i.xscalechange
				i.yscale:+i.yscalechange
				i.ang:+i.angchange

				i.x=(i.x+Sin(i.ang)*i.accel)
				i.y=(i.y+Cos(i.ang)*i.accel)

				AddImage(i.img,i.x-WINDOWx,i.y-WINDOWy,0,i.r,i.g,i.b,i.alpha,i.rot,i.xscale,i.yscale,i.blend)

				If (i.x-i.collrad)<WINleft
					ang=(180-i.ang)
					ang:+180
					i.ang=ang
					i.rot= (-ang)+180
					i.x=(WINleft+i.collrad)
				Else
					If (i.x+i.collrad)>WINright
						ang=(180-i.ang)
						ang:+180
						i.ang=ang
						i.rot= (-ang)+180
						i.x=(WINright-i.collrad)
					End If
				End If

	
				If (i.y-i.collrad)<WINtop
					ang=(90-i.ang)
					ang:+90
					i.ang=ang
					i.rot= (-ang)+180
					i.y=(WINtop+i.collrad)
				Else
					If (i.y+i.collrad)>WINbot
						ang=(90-i.ang)+90
						'ang:+90
						i.ang=ang
						i.rot= (-ang)+180
						i.y=(WINbot-i.collrad)
					End If
				End If

				If i.accel<=0 Or i.alpha<0
					particlelist.remove i
				End If
			Case	1
				i.accel:+i.accelchange
				i.alpha:+i.alphachange
				i.rot:+i.rotchange
				i.xscale:+i.xscalechange
				i.yscale:+i.yscalechange
				i.ang:+i.angchange

				i.x=(i.x+Sin(i.ang)*i.accel)
				i.y=(i.y+Cos(i.ang)*i.accel)

				If i.r>0
					i.r:+i.rcolchange
				End If

				If i.g>0
					i.g:+i.gcolchange
				End If

				If i.b>0
					i.b:+i.bcolchange
				End If

				AddImage(i.img,i.x-WINDOWx,i.y-WINDOWy,0,i.r,i.g,i.b,i.alpha,i.rot,i.xscale,i.yscale,i.blend)

				If i.accel<=0 Or i.alpha<0
					particlelist.remove i
				End If
			Case	2
				i.accel:+i.accelchange
				i.alpha:+i.alphachange
				i.rot:+i.rotchange
				i.xscale:+i.xscalechange
				i.yscale:+i.yscalechange
				i.ang:+i.angchange

				i.x=(i.x+Sin(i.ang)*i.accel)
				i.y=(i.y+Cos(i.ang)*i.accel)

				i.rcolchange:-1
				If i.rcolchange=0
					i.rcolchange=i.gcolchange
					i.bcolchange=(i.bcolchange+1) Mod 2
				End If

				If i.bcolchange=1
					AddImage(i.img,i.x-WINDOWx,i.y-WINDOWy,0,i.r,i.g,i.b,i.alpha,i.rot,i.xscale,i.yscale,i.blend)
				End If

				If i.accel<=0 Or i.alpha<0
					particlelist.remove i
				End If
			Case	3
				i.accel:+i.accelchange
				i.alpha:+i.alphachange
				i.rot:+i.rotchange
				i.xscale:+i.xscalechange
				i.yscale:+i.yscalechange
				i.ang:+i.angchange

				i.x=(i.x+Sin(i.ang)*i.accel)
				i.y=(i.y+Cos(i.ang)*i.accel)

				i.y:+1

				AddImage(i.img,i.x-WINDOWx,i.y-WINDOWy,0,i.r,i.g,i.b,i.alpha,i.rot,i.xscale,i.yscale,i.blend)

				If i.accel<=0 Or i.alpha<0
					particlelist.remove i
				End If
		End Select
	Next
End Function

