'////////////////////////////////////////////////////////////////////////////////
'//	Variables
'////////////////////////////////////////////////////////////////////////////////
Global	GFXstar01:TImage
Global	GFXstar02:TImage
Global	GFXstar03:TImage

Type	tSTAR
	Field	x:Float
	Field	y:Float
	Field	s:Float
	Field	r:Int
	Field	g:Int
	Field	b:Int
	Field	tw:Int
End Type
Global STARlist:TList=CreateList()

'////////////////////////////////////////////////////////////////////////////////
'//	Setup Stars
'////////////////////////////////////////////////////////////////////////////////
Function	SetupStars()
	Local	i:Int
	Local	star:tSTAR

	If CONFstars<>0
		For i=0 To MAXSTARS
			star:tSTAR = New tSTAR
			star.s=Rand(2,7)
			Select star.s
				Case	2
				star.x=Rand(0,GFXw+800)
				star.y=Rand(0,GFXh+600)
				Case	3
				star.x=Rand(0,GFXw+300)
				star.y=Rand(0,GFXh+200)
				Case	4
				star.x=Rand(0,GFXw+200)
				star.y=Rand(0,GFXh+150)
				Case	5
				star.x=Rand(0,GFXw+200)
				star.y=Rand(0,GFXh+150)
				Case	6
				star.x=Rand(0,GFXw+150)
				star.y=Rand(0,GFXh+100)
				Case	7
				star.x=Rand(0,GFXw+120)
				star.y=Rand(0,GFXh+80)
			End Select
			star.r=Rand(64,256)
			star.g=Rand(64,256)
			star.b=Rand(64,256)
			star.tw=Rand(16,512)
			ListAddLast(starlist,star)
		Next
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Draw Stars
'////////////////////////////////////////////////////////////////////////////////
Function	DrawStars()
	Local	i:tSTAR
	Local	xp:Float
	Local	yp:Float
	Local	t:Float[]=[1.0,1.1,1.2,1.3,1.4,1.5,1.6,1.7,1.8,1.7,1.6,1.5,1.4,1.3,1.2,1.1]
	Local	s:Float

	If CONFstars<>0

		For	i:tSTAR = EachIn starlist
			xp=(i.x-(WINDOWx/i.s))
			yp=(i.y-(WINDOWy/i.s))

			i.tw:-1
			If i.tw<0
				i.tw=Rand(16,512)
			End If
			If i.tw<16
				s=t[i.tw]
			Else
				s=1
			End If

			If xp>0 And xp<GFXw And yp>0 And yp<GFXh
				Select	i.s
					Case	2
						AddImage(GFXstar03,xp,yp,0,i.r,i.g,i.b,1,0,s,s,lightBLEND)
					Case	3
						AddImage(GFXstar03,xp,yp,0,i.r,i.g,i.b,1,0,s,s,lightBLEND)
					Case	4
						AddImage(GFXstar02,xp,yp,0,i.r,i.g,i.b,1,0,s,s,lightBLEND)
					Case	5
						AddImage(GFXstar02,xp,yp,0,i.r,i.g,i.b,1,0,s,s,lightBLEND)
					Case	6
						AddImage(GFXstar01,xp,yp,0,i.r,i.g,i.b,1,0,s,s,lightBLEND)
					Case	7
						AddImage(GFXstar01,xp,yp,0,i.r,i.g,i.b,1,0,s,s,lightBLEND)
				End Select
			End If
		Next	
	End If
End Function

